﻿;***comDoc***
;============
;
;Open image document demo program.
;
;This opens the document created with the "Demo - CreateDocument.pb" demo and allows the user to view the images contained within.
;/////////////////////////////////////////////////////////////////////////////////

CoInitialize_(0)

XIncludeFile "..\..\comDoc.pbi"

;GUI constants.
  #WindowWidth = 350
  #WindowHeight = 200

  #MainWindow = 0
  #ImageWindow = 1

  Enumeration
    #FrameGadget
    #ListIcon
    #ScrollArea
    #ImageGadget
  EndEnumeration


Define myDoc.comDocDocumentObject, myFile.comDocFileObject

;Open our disc-based compound document.
  myDoc = comDoc_OpenDiscDocument("images.cmp")

If myDoc
  If OpenWindow(#MainWindow, 0, 0, #WindowWidth, #WindowHeight, "comDoc image document", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    Frame3DGadget(#FrameGadget, 10, 10, #WindowWidth - 20, #WindowHeight - 20, "Double click image to view...")
    ListIconGadget(#ListIcon, 20, 40, #WindowWidth - 40, #WindowHeight - 60, "Image file", 150, #PB_ListIcon_FullRowSelect)
      AddGadgetColumn(#ListIcon, 1, "Size (bytes)", 150)
    ;Enumerate our document and add all image files found to the list icon.
      If myDoc\BeginEnumeration()
        While myDoc\NextEnumerationEntry()
          AddGadgetItem(#ListIcon, -1, myDoc\EnumerationEntryName() + #LF$ + Str(myDoc\EnumerationEntrySize()))
        Wend
        myDoc\FinishEnumeration()
      EndIf
    ;Open a window to display the selected image.
      OpenWindow(#ImageWindow, 0, 0, 400, 400, "comDoc image document", #PB_Window_TitleBar|#PB_Window_Invisible, WindowID(#MainWindow))
      ScrollAreaGadget(#ScrollArea, 10, 10, 380, 380, 1000, 1000, 30, #PB_ScrollArea_Flat|#PB_ScrollArea_Center)
        ImageGadget(#ImageGadget, 0, 0, 0, 0, 0)
      CloseGadgetList()
    Repeat
      eventID = WaitWindowEvent()
      Select eventID
        Case #PB_Event_Gadget
          Select EventGadget()
            Case #ListIcon
              If EventType() = #PB_EventType_LeftDoubleClick
                item = GetGadgetState(#ListIcon)
                If item >-1
                  If IsImage(1)
                    FreeImage(1)
                  EndIf
                  ;Open the appropriate document image file.
                    myFile = myDoc\OpenFile("image" + Str(item+1))
                    If myfile
                      numBytes = myFile\Lof()
                      If numBytes
                        buffer = AllocateMemory(numBytes)
                        If buffer
                          myFile\ReadData(buffer, numBytes)
                          If CatchImage(1, buffer, numBytes)
                            SetGadgetState(#ImageGadget, ImageID(1))
                            SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_InnerWidth, ImageWidth(1))
                            SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_InnerHeight, ImageHeight(1))
                            HideWindow(#ImageWindow, 0)
                            SetActiveGadget(#Listicon)
                          EndIf
                          FreeMemory(buffer)                        
                        EndIf
                      EndIf
                      myfile\Close()                    
                    EndIf
                EndIf
              EndIf          
            
          EndSelect
      EndSelect
    Until eventID = #PB_Event_CloseWindow    
  EndIf
  myDoc\Close()
Else
  MessageRequester("comDoc!", "Could not open the 'images.cmp' compound document! Check that it exists!")
EndIf


; IDE Options = PureBasic 4.50 Beta 3 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 30
; FirstLine = 28
; EnableUnicode
; EnableXP
; Executable = nxReportU.dll